[tool.ruff]
preview = true
line-length = 120
indent-width = 4
select = [ "ALL" ]
ignore = [
    "ANN002",  # *args typing
    "ANN003",  # **kwargs typing
    "ANN101",  # self typing
    "ANN102",  # cls typing
    "COM",  # All comment rules like "missing a full stop"
    "CPY001",  # Missing copyright notice at top of file
    "D",  # All pydocstyles rules
    "EM101", # Exception must not use a string literal, assing to a variable first
    "EM102", # Exception must not use a f-string
    "FBT001",  # Boolean-typed positional argument in function definition
    "FBT002",  # Boolean default positional argument in function definition
    "FIX001",  # Line contains FIXME, we do not want to do this now, remove this when needed
    "G004", # Logging statement using f-string
    "I001",  # Sorted import, for some reason it does not work, even after the use of Isort
    "PLR6301", # Method could be a function, class method, or static method
    "PT009",  # Use a regular "assert" instead of unittest-style "assertEqual"
    "Q000", # Prefer double quotes over single quotes
    "TD001",  # Invalid TODO tags (like FIXME)
    "TD002",  # Missing author in TODO; try: `# TODO(<author_name>): ...` or `# TODO @<author_name>: ...`
    "TD003",  # Missing issue link on the line following this TODO
    "TRY003", # Avoid specific long messages outside the exception class
    "TRY401",  # Redundant exception object included in `logging.exception` call
    "UP007", # Use `X | Y` for type annotations
]

target-version = "py39"

[tool.ruff.per-file-ignores]
"test_*.py" = [
    "S101",  # Use of `assert` detected
    "SLF001",  # Private member accessed
    "ANN401",  # Dynamically typed expressions disallowed (Any)
    "ARG001",  # Unused function arguments
    "S105",  # Possible hardcoded password
]


[tool.pyright]
pythonVersion = "3.9"
reportGeneralTypeIssues = false
reportOptionalMemberAccess = false


[tool.ruff.format]
# Like Black, use double quotes for strings.
quote-style = "double"

# Like Black, indent with spaces, rather than tabs.
indent-style = "space"

# Like Black, respect magic trailing commas.
skip-magic-trailing-comma = false

# Like Black, automatically detect the appropriate line ending.
line-ending = "auto"

# Enable auto-formatting of code examples in docstrings. Markdown,
# reStructuredText code/literal blocks and doctests are all supported.
#
# This is currently disabled by default, but it is planned for this
# to be opt-out in the future.
docstring-code-format = false

# Set the line length limit used when formatting code snippets in
# docstrings.
#
# This only has an effect when the `docstring-code-format` setting is
# enabled.
docstring-code-line-length = "dynamic"
